n, q, k = map(int, input().split())
favorite_permutation = list(map(int, input().split()))

# Изначальный порядок выполнения дел
initial_order = list(range(1, n + 1))

for i in range(q):
    l, r = map(int, input().split())
    priority = favorite_permutation[l - 1:r]
    priority.sort()  # Сортируем приоритеты
    initial_order[l - 1:r] = priority  # Заменяем порядок дел

# Найдем дело, которое Юрик выполнит k-м по счету
result = initial_order[k - 1]

print(result)